<?php
 /*
   Limph Is Monitoring Pingable Hosts
   Copyright (C) 2006 Jonathan Ciesla
   
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
  */
require_once("functionlib.php");

$dbhost="";
$dbuser="";
$dbpass="";
$dbname="";

$dbtype = "my"; // Use my for MySQL(default), pg for PostgreSQL, sl for SQLite, slpdo for SQLite via PDO extension
$dbpath = "/path/to/your.db"; //Place outside of webroot for security

$link = dbms_connect($dbhost, $dbuser, $dbpass, $dbname);

$version = "1.9.4";

$query = "UPDATE universal SET version = '$version';";
dbms_query($query);

if($dbtype=="my"){
  $query = "ALTER TABLE `groups` ADD `collapse` ENUM('0', '1') NOT NULL;";
  dbms_query($query);
  
  $query = "UPDATE `hosts` SET `collapse` = '0' WHERE collapse IS NULL;";
  dbms_query($query);
  
  $query = "ALTER TABLE `universal` ADD `textsize` ENUM('xx-small', 'x-small', 'small', 'medium', 'large', 'x-large', 'xx-large') DEFAULT 'small' NOT NULL ;";
  dbms_query($query);
  
  $query = "ALTER TABLE `universal` ADD `tabletextsize` ENUM('xx-small', 'x-small', 'small', 'medium', 'large', 'x-large', 'xx-large') DEFAULT 'x-small' NOT NULL ;";
  dbms_query($query);
  
  $query = "ALTER TABLE `universal` ADD `autoupdateip` ENUM('0', '1') NOT NULL AFTER `year`;";
  dbms_query($query);
  
  $query = "ALTER TABLE `history` ADD `host` SMALLINT(6) NOT NULL AFTER `hostname` ;";
  dbms_query($query);
  
  $query = "UPDATE history,hosts SET history.host = hosts.number WHERE hosts.name = history.hostname;";
  dbms_query($query);
  
  $query = "ALTER TABLE `hosts` ADD `parent` SMALLINT(6) NOT NULL;";
  dbms_query($query);
  
  $query = "ALTER TABLE `hosts` ADD `visible` ENUM('1', '0') NOT NULL;";
  dbms_query($query);
  
  $query = "ALTER TABLE `hosts` CHANGE `group` `hostgroup` SMALLINT(4) NOT NULL DEFAULT '0';";
  dbms_query($query);
  
  $query = "ALTER TABLE `groups` CHANGE `collapse` `collapse` VARCHAR(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '0';";
  dbms_query($query);

  $query = "ALTER TABLE `history` CHANGE `host` `host` INT(6) NOT NULL DEFAULT '0';";
  dbms_query($query);

  $query = "ALTER TABLE `history` CHANGE `type` `type` VARCHAR(4) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT 'Up';";
  dbms_query($query);

  $query = "ALTER TABLE `hosts` CHANGE `number` `number` INT(6) NOT NULL DEFAULT '0';";
  dbms_query($query);

  $query = "ALTER TABLE `hosts` CHANGE `status` `status` VARCHAR(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '1',
CHANGE `enabled` `enabled` VARCHAR(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '1',
CHANGE `type` `type` VARCHAR(3) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT 'udp',
CHANGE `visible` `visible` VARCHAR(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '1';";
  dbms_query($query);

  $query = "ALTER TABLE `universal` CHANGE `notify` `notify` VARCHAR(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '0',
CHANGE `autoupdateip` `autoupdateip` VARCHAR(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '0',
CHANGE `textsize` `textsize` VARCHAR(8) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT 'small',
CHANGE `tabletextsize` `tabletextsize` VARCHAR(8) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT 'x-small';";
  dbms_query($query);

  $query = "ALTER TABLE `users` CHANGE `number` `number` INT(6) NOT NULL DEFAULT '0',
CHANGE `admin` `admin` VARCHAR(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '0',
CHANGE `notify` `notify` VARCHAR(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '1',
CHANGE `digest` `digest` VARCHAR(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '1';";
  dbms_query($query);

  $query = "CREATE TABLE `state` (`number` INT NOT NULL, `datetime` DATETIME NOT NULL, `hostname` VARCHAR(40) NOT NULL, `type` VARCHAR(20) NOT NULL, `data` VARCHAR(50) NOT NULL, `disk` VARCHAR(20) NOT NULL, PRIMARY KEY ( `number` )) ENGINE = MYISAM;";
  dbms_query($query);

  $query = "CREATE TABLE `thresholds` (`number` INT NOT NULL, `hostname` VARCHAR(50) NOT NULL, `type` VARCHAR(20) NOT NULL, `value` VARCHAR(20) NOT NULL, `disk` VARCHAR(20) NOT NULL, PRIMARY KEY (`number`)) ENGINE = MYISAM;";
  dbms_query($query);

  $query = "ALTER TABLE `universal` ADD `status_public` VARCHAR(1) NOT NULL DEFAULT '0';";
  dbms_query($query);

  $query = "CREATE TABLE `host_notif` (`number` INT(10) NOT NULL, `host` INT(6) NOT NULL, `user` INT(6) NOT NULL, PRIMARY KEY ( `number` )
) ENGINE = MYISAM ;";
  dbms_query($query);

 } else {
  
  $query = "CREATE TABLE state (number integer NOT NULL, datetime timestamp without time zone NOT NULL, hostname character varying NOT NULL, \"type\" character varying NOT NULL, data character varying NOT NULL, disk character varying NOT NULL);";
  dbms_query($query);
  
  $query = "ALTER TABLE ONLY state ADD CONSTRAINT \"state.number\" PRIMARY KEY (number);"; $query = "ALTER TABLE ONLY state ADD CONSTRAINT \"state.number\" PRIMARY KEY (number);";
  
  $query = "CREATE TABLE thresholds (number INT NOT NULL, hostname character varying NOT NULL, type character varying NOT NULL, value character varying NOT NULL, disk character varying NOT NULL;";
  dbms_query($query);
  
  $query = "ALTER TABLE ONLY thresholds ADD CONSTRAINT \"thresholds.number\" PRIMARY KEY (number);";
  
  $query = "ALTER TABLE ONLY universal ADD COLUMN status_public character varying NOT NULL;";
  dbms_query($query);
  
  $query = "CREATE TABLE host_notif (number integer NOT NULL, host integer NOT NULL, user integer NOT NULL;";
  dbms_query($query);
  
  $query = "ALTER TABLE ONLY host_notif ADD CONSTRAINT \"host_notif.number\" PRIMARY KEY (number);";
  dbms_query($query);

 };
  
dbms_close($link);

?>